/**
 */
package de.mdelab.mlstorypatterns;

import de.mdelab.mlexpressions.MLExpression;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Expression Link</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * An ExpressionLink uses an expression to determine the set of elements in which a match for the target object is sought.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.ExpressionLink#getExpression <em>Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getExpressionLink()
 * @model
 * @generated
 */
public interface ExpressionLink extends AbstractStoryPatternLink {
	/**
	 * Returns the value of the '<em><b>Expression</b></em>' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> The link's expression. The context of the expression
	 * is the source object. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Expression</em>' containment reference.
	 * @see #setExpression(MLExpression)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getExpressionLink_Expression()
	 * @model containment="true" required="true"
	 * @generated
	 */
	MLExpression getExpression();

	/**
	 * Sets the value of the '{@link de.mdelab.mlstorypatterns.ExpressionLink#getExpression <em>Expression</em>}' containment reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Expression</em>' containment reference.
	 * @see #getExpression()
	 * @generated
	 */
	void setExpression(MLExpression value);

} // ExpressionLink
