/**
 */
package de.mdelab.mlstorypatterns;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Story Pattern Element</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Superclass of all elements that may be contained in a StoryPattern, i.e., objects and links.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.StoryPatternElement#getModifier <em>Modifier</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.StoryPatternElement#getMatchType <em>Match Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getStoryPatternElement()
 * @model abstract="true"
 * @generated
 */
public interface StoryPatternElement extends MLElementWithUUID,
		MLAnnotatedElement {
	/**
	 * Returns the value of the '<em><b>Modifier</b></em>' attribute. The
	 * literals are from the enumeration
	 * {@link de.mdelab.mlstorypatterns.ModifierEnum}. <!-- begin-user-doc -->
	 * <!-- end-user-doc --> <!-- begin-model-doc --> The modifier specifies how
	 * the element is modified, when the StoryPattern is applied, i.e., whether
	 * the element is created, deleted, or left unchanged. <!-- end-model-doc
	 * -->
	 * 
	 * @return the value of the '<em>Modifier</em>' attribute.
	 * @see de.mdelab.mlstorypatterns.ModifierEnum
	 * @see #setModifier(ModifierEnum)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getStoryPatternElement_Modifier()
	 * @model required="true"
	 * @generated
	 */
	ModifierEnum getModifier();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlstorypatterns.StoryPatternElement#getModifier
	 * <em>Modifier</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Modifier</em>' attribute.
	 * @see de.mdelab.mlstorypatterns.ModifierEnum
	 * @see #getModifier()
	 * @generated
	 */
	void setModifier(ModifierEnum value);

	/**
	 * Returns the value of the '<em><b>Match Type</b></em>' attribute. The
	 * literals are from the enumeration
	 * {@link de.mdelab.mlstorypatterns.MatchTypeEnum}. <!-- begin-user-doc -->
	 * <!-- end-user-doc --> <!-- begin-model-doc --> The match type can be used
	 * to specify that the element has to be matched in a special way. <!--
	 * end-model-doc -->
	 * 
	 * @return the value of the '<em>Match Type</em>' attribute.
	 * @see de.mdelab.mlstorypatterns.MatchTypeEnum
	 * @see #setMatchType(MatchTypeEnum)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getStoryPatternElement_MatchType()
	 * @model required="true"
	 * @generated
	 */
	MatchTypeEnum getMatchType();

	/**
	 * Sets the value of the '{@link de.mdelab.mlstorypatterns.StoryPatternElement#getMatchType <em>Match Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Match Type</em>' attribute.
	 * @see de.mdelab.mlstorypatterns.MatchTypeEnum
	 * @see #getMatchType()
	 * @generated
	 */
	void setMatchType(MatchTypeEnum value);

} // StoryPatternElement
