package de.mdelab.mlstorypatterns.diagram.custom.edit.parts;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.expressiondialogs.Utility;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel8EditPart;

public class CustomMapEntryLinkValueLinkLabelEditPart extends WrappingLabel8EditPart
{

	public CustomMapEntryLinkValueLinkLabelEditPart(View view)
	{
		super(view);
	}

	@Override
	protected void addNotationalListeners()
	{
		super.addNotationalListeners();

		MapEntryLink mapEntryStoryPatternLink = (MapEntryLink) ((Edge) ((View) getModel()).eContainer())
				.getSource().getElement();

		addListenerFilter("MapEntryStoryPatternLink", this, mapEntryStoryPatternLink);
	}

	@Override
	protected void handleNotificationEvent(Notification notification)
	{
		if (notification.getEventType() != Notification.REMOVE
				&& (notification.getNotifier() instanceof MapEntryLink || notification.getNotifier() instanceof StoryPatternObject))
		{
			adaptColor();
		}

		super.handleNotificationEvent(notification);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		adaptColor();
	}

	protected void adaptColor()
	{
		if (((Edge) ((View) getModel()).eContainer()).getSource() != null)
		{
			ModifierEnum modifier = ((StoryPatternElement) ((Edge) ((View) getModel()).eContainer()).getSource()
					.getElement()).getModifier();

			Utility.adaptColor(getFigure(), modifier);
		}
	}
}
