package de.mdelab.mlstorypatterns.diagram.custom.part.expressions;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.swt.widgets.Shell;

import de.mdelab.mlcallactions.VariableDeclarationAction;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.ActivityParameterDirectionEnum;
import de.mdelab.mlstorypatterns.StoryPatternObject;

public class EditExpressionDialog extends CommonEditExpressionDialog
{

	public EditExpressionDialog(Shell parent)
	{
		super(parent);
	}

	private Activity	activity;

	public void setActivity(Activity activity)
	{
		this.activity = activity;
		this.setRootContainer(activity);
	}

	@Override
	protected Map<String, EClassifier> getContextInformation()
	{
		Map<String, EClassifier> contextInfos = new HashMap<String, EClassifier>();

		if (this.activity != null)
		{
			/*
			 * THIS and parameters
			 */
			if (this.activity/*.getSpecification()*/ != null)
			{
//				EClass thisClass = null;//this.activity.getSpecification().getEContainingClass();
//
//				if (thisClass != null)
//				{
//					contextInfos.put("this", thisClass);
//				}

				for (ActivityParameter parameter : this.activity.getParameters())
				{
					if (parameter.getName() != null && !"".equals(parameter) && parameter.getType() != null)
					{
						contextInfos.put(parameter.getName(), parameter.getType());
					}
				}
			}
			else
			{
				for (ActivityParameter parameter : this.activity.getParameters())
				{
					if ((parameter.getDirection() == ActivityParameterDirectionEnum.IN || parameter.getDirection() == ActivityParameterDirectionEnum.OUT)
							&& parameter.getName() != null && !"".equals(parameter) && parameter.getType() != null)
					{
						contextInfos.put(parameter.getName(), parameter.getType());
					}
				}
			}

			/*
			 * Variables created in story patterns and
			 * VariableDeclarationActions
			 */
			TreeIterator<EObject> it = this.activity.eAllContents();

			while (it.hasNext())
			{
				EObject eObject = it.next();

				if (eObject instanceof StoryPatternObject)
				{
					StoryPatternObject spo = (StoryPatternObject) eObject;

					if (spo.getName() != null && !"".equals(spo.getName()) && spo.getType() != null)
					{
						contextInfos.put(spo.getName(), spo.getType());
					}
				}
				else if (eObject instanceof VariableDeclarationAction)
				{
					VariableDeclarationAction vda = (VariableDeclarationAction) eObject;

					if (vda.getName() != null && !"".equals(vda.getName()) && vda.getType() != null)
					{
						contextInfos.put(vda.getName(), vda.getType());
					}
				}
			}
		}

		return contextInfos;
	}

}
