package de.mdelab.mlstorypatterns.diagram.custom.part.expressions;



import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gmf.runtime.diagram.ui.editparts.CompartmentEditPart;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPatternObject;

public class EditStoryPatternObjectConstraintExpressionAction extends EditExpressionAction
{

	@Override
	protected EClassifier getExpectedClassifier()
	{
		return EcorePackage.eINSTANCE.getEBoolean();
	}

	@Override
	protected MLExpression getExpression()
	{
		return (MLExpression) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement();
	}

	@Override
	protected TransactionalEditingDomain getEditingDomain()
	{
		return ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getEditingDomain();
	}

	@Override
	protected void setNewExpression(MLExpression newExpression)
	{
		MLExpression oldExpression = getExpression();
		StoryPatternObject spo = (StoryPatternObject) oldExpression.eContainer();

		spo.getConstraints().remove(oldExpression);
		spo.getConstraints().add(newExpression);
	}

	@Override
	protected EClassifier getContextClassifier()
	{
		return ((StoryPatternObject) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getParent().getParent()
				.getModel()).getElement()).getType();
	}

	@Override
	protected Activity getActivity()
	{
		EObject container = ((StoryPatternObject) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getParent()
				.getParent().getModel()).getElement()).eContainer();

		while (!(container instanceof Activity))
		{
			if (container==null) return null;
			container = container.eContainer();
		}

		return (Activity) container;
	}

	@Override
	protected EObject getExpressionOwner()
	{
		return this.getExpression().eContainer();
	}

	@Override
	protected void prepareDialog()
	{
		super.prepareDialog();
		editExpressionDialog.setStructuralFeature(MlstorypatternsPackage.eINSTANCE.getStoryPatternObject_Constraints());
	}
}
