package de.mdelab.mlstorypatterns.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;

import org.eclipse.gmf.tooling.runtime.update.DiagramUpdater;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.ContainmentLink;
import de.mdelab.mlstorypatterns.ExpressionLink;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import de.mdelab.mlstorypatterns.diagram.edit.parts.AttributeAssignmentEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.CallActionExpressionEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.LinkOrderConstraintEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MLStringExpressionEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart;
import de.mdelab.mlstorypatterns.diagram.providers.MlstorypatternsElementTypes;

/**
 * @generated
 */
public class MlstorypatternsDiagramUpdater {

	/**
	 * @generated
	 */
	public static List<MlstorypatternsNodeDescriptor> getSemanticChildren(
			View view) {
		switch (MlstorypatternsVisualIDRegistry.getVisualID(view)) {
		case StoryPatternEditPart.VISUAL_ID:
			return getStoryPattern_1000SemanticChildren(view);
		case StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID:
			return getStoryPatternObjectStoryPatternObjectConstraintsCompartment_7001SemanticChildren(view);
		case StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID:
			return getStoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartment_7002SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsNodeDescriptor> getStoryPattern_1000SemanticChildren(
			View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		StoryPattern modelElement = (StoryPattern) view.getElement();
		LinkedList<MlstorypatternsNodeDescriptor> result = new LinkedList<MlstorypatternsNodeDescriptor>();
		for (Iterator<?> it = modelElement.getStoryPatternObjects().iterator(); it
				.hasNext();) {
			AbstractStoryPatternObject childElement = (AbstractStoryPatternObject) it
					.next();
			int visualID = MlstorypatternsVisualIDRegistry.getNodeVisualID(
					view, childElement);
			if (visualID == StoryPatternObjectEditPart.VISUAL_ID) {
				result.add(new MlstorypatternsNodeDescriptor(childElement,
						visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsNodeDescriptor> getStoryPatternObjectStoryPatternObjectConstraintsCompartment_7001SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		StoryPatternObject modelElement = (StoryPatternObject) containerView
				.getElement();
		LinkedList<MlstorypatternsNodeDescriptor> result = new LinkedList<MlstorypatternsNodeDescriptor>();
		for (Iterator<?> it = modelElement.getConstraints().iterator(); it
				.hasNext();) {
			MLExpression childElement = (MLExpression) it.next();
			int visualID = MlstorypatternsVisualIDRegistry.getNodeVisualID(
					view, childElement);
			if (visualID == MLStringExpressionEditPart.VISUAL_ID) {
				result.add(new MlstorypatternsNodeDescriptor(childElement,
						visualID));
				continue;
			}
			if (visualID == CallActionExpressionEditPart.VISUAL_ID) {
				result.add(new MlstorypatternsNodeDescriptor(childElement,
						visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsNodeDescriptor> getStoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartment_7002SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		StoryPatternObject modelElement = (StoryPatternObject) containerView
				.getElement();
		LinkedList<MlstorypatternsNodeDescriptor> result = new LinkedList<MlstorypatternsNodeDescriptor>();
		for (Iterator<?> it = modelElement.getAttributeAssignments().iterator(); it
				.hasNext();) {
			AttributeAssignment childElement = (AttributeAssignment) it.next();
			int visualID = MlstorypatternsVisualIDRegistry.getNodeVisualID(
					view, childElement);
			if (visualID == AttributeAssignmentEditPart.VISUAL_ID) {
				result.add(new MlstorypatternsNodeDescriptor(childElement,
						visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getContainedLinks(
			View view) {
		switch (MlstorypatternsVisualIDRegistry.getVisualID(view)) {
		case StoryPatternEditPart.VISUAL_ID:
			return getStoryPattern_1000ContainedLinks(view);
		case StoryPatternObjectEditPart.VISUAL_ID:
			return getStoryPatternObject_2003ContainedLinks(view);
		case MLStringExpressionEditPart.VISUAL_ID:
			return getMLStringExpression_3001ContainedLinks(view);
		case AttributeAssignmentEditPart.VISUAL_ID:
			return getAttributeAssignment_3002ContainedLinks(view);
		case CallActionExpressionEditPart.VISUAL_ID:
			return getCallActionExpression_3003ContainedLinks(view);
		case StoryPatternLinkEditPart.VISUAL_ID:
			return getStoryPatternLink_4001ContainedLinks(view);
		case ContainmentLinkEditPart.VISUAL_ID:
			return getContainmentLink_4002ContainedLinks(view);
		case ExpressionLinkEditPart.VISUAL_ID:
			return getExpressionLink_4003ContainedLinks(view);
		case LinkOrderConstraintEditPart.VISUAL_ID:
			return getLinkOrderConstraint_4004ContainedLinks(view);
		case MapEntryLinkEditPart.VISUAL_ID:
			return getMapEntryLink_4005ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getIncomingLinks(View view) {
		switch (MlstorypatternsVisualIDRegistry.getVisualID(view)) {
		case StoryPatternObjectEditPart.VISUAL_ID:
			return getStoryPatternObject_2003IncomingLinks(view);
		case MLStringExpressionEditPart.VISUAL_ID:
			return getMLStringExpression_3001IncomingLinks(view);
		case AttributeAssignmentEditPart.VISUAL_ID:
			return getAttributeAssignment_3002IncomingLinks(view);
		case CallActionExpressionEditPart.VISUAL_ID:
			return getCallActionExpression_3003IncomingLinks(view);
		case StoryPatternLinkEditPart.VISUAL_ID:
			return getStoryPatternLink_4001IncomingLinks(view);
		case ContainmentLinkEditPart.VISUAL_ID:
			return getContainmentLink_4002IncomingLinks(view);
		case ExpressionLinkEditPart.VISUAL_ID:
			return getExpressionLink_4003IncomingLinks(view);
		case LinkOrderConstraintEditPart.VISUAL_ID:
			return getLinkOrderConstraint_4004IncomingLinks(view);
		case MapEntryLinkEditPart.VISUAL_ID:
			return getMapEntryLink_4005IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getOutgoingLinks(View view) {
		switch (MlstorypatternsVisualIDRegistry.getVisualID(view)) {
		case StoryPatternObjectEditPart.VISUAL_ID:
			return getStoryPatternObject_2003OutgoingLinks(view);
		case MLStringExpressionEditPart.VISUAL_ID:
			return getMLStringExpression_3001OutgoingLinks(view);
		case AttributeAssignmentEditPart.VISUAL_ID:
			return getAttributeAssignment_3002OutgoingLinks(view);
		case CallActionExpressionEditPart.VISUAL_ID:
			return getCallActionExpression_3003OutgoingLinks(view);
		case StoryPatternLinkEditPart.VISUAL_ID:
			return getStoryPatternLink_4001OutgoingLinks(view);
		case ContainmentLinkEditPart.VISUAL_ID:
			return getContainmentLink_4002OutgoingLinks(view);
		case ExpressionLinkEditPart.VISUAL_ID:
			return getExpressionLink_4003OutgoingLinks(view);
		case LinkOrderConstraintEditPart.VISUAL_ID:
			return getLinkOrderConstraint_4004OutgoingLinks(view);
		case MapEntryLinkEditPart.VISUAL_ID:
			return getMapEntryLink_4005OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getStoryPattern_1000ContainedLinks(
			View view) {
		StoryPattern modelElement = (StoryPattern) view.getElement();
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_StoryPatternLink_4001(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_ContainmentLink_4002(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_ExpressionLink_4003(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_LinkOrderConstraint_4004(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_MapEntryLink_4005(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getStoryPatternObject_2003ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getMLStringExpression_3001ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getAttributeAssignment_3002ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getCallActionExpression_3003ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getStoryPatternLink_4001ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getContainmentLink_4002ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getExpressionLink_4003ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getLinkOrderConstraint_4004ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getMapEntryLink_4005ContainedLinks(
			View view) {
		MapEntryLink modelElement = (MapEntryLink) view.getElement();
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_MapEntryLink_ValueTarget_4006(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getStoryPatternObject_2003IncomingLinks(
			View view) {
		StoryPatternObject modelElement = (StoryPatternObject) view
				.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_StoryPatternLink_4001(
				modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_ContainmentLink_4002(
				modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_ExpressionLink_4003(
				modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_MapEntryLink_4005(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_MapEntryLink_ValueTarget_4006(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getMLStringExpression_3001IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getAttributeAssignment_3002IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getCallActionExpression_3003IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getStoryPatternLink_4001IncomingLinks(
			View view) {
		StoryPatternLink modelElement = (StoryPatternLink) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_LinkOrderConstraint_4004(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getContainmentLink_4002IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getExpressionLink_4003IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getLinkOrderConstraint_4004IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getMapEntryLink_4005IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getStoryPatternObject_2003OutgoingLinks(
			View view) {
		StoryPatternObject modelElement = (StoryPatternObject) view
				.getElement();
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_StoryPatternLink_4001(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_ContainmentLink_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_ExpressionLink_4003(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_MapEntryLink_4005(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getMLStringExpression_3001OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getAttributeAssignment_3002OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getCallActionExpression_3003OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getStoryPatternLink_4001OutgoingLinks(
			View view) {
		StoryPatternLink modelElement = (StoryPatternLink) view.getElement();
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_LinkOrderConstraint_4004(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getContainmentLink_4002OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getExpressionLink_4003OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getLinkOrderConstraint_4004OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlstorypatternsLinkDescriptor> getMapEntryLink_4005OutgoingLinks(
			View view) {
		MapEntryLink modelElement = (MapEntryLink) view.getElement();
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_MapEntryLink_ValueTarget_4006(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getContainedTypeModelFacetLinks_StoryPatternLink_4001(
			StoryPattern container) {
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof StoryPatternLink) {
				continue;
			}
			StoryPatternLink link = (StoryPatternLink) linkObject;
			if (StoryPatternLinkEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlstorypatternsLinkDescriptor(src, dst, link,
					MlstorypatternsElementTypes.StoryPatternLink_4001,
					StoryPatternLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getContainedTypeModelFacetLinks_ContainmentLink_4002(
			StoryPattern container) {
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof ContainmentLink) {
				continue;
			}
			ContainmentLink link = (ContainmentLink) linkObject;
			if (ContainmentLinkEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlstorypatternsLinkDescriptor(src, dst, link,
					MlstorypatternsElementTypes.ContainmentLink_4002,
					ContainmentLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getContainedTypeModelFacetLinks_ExpressionLink_4003(
			StoryPattern container) {
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof ExpressionLink) {
				continue;
			}
			ExpressionLink link = (ExpressionLink) linkObject;
			if (ExpressionLinkEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlstorypatternsLinkDescriptor(src, dst, link,
					MlstorypatternsElementTypes.ExpressionLink_4003,
					ExpressionLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getContainedTypeModelFacetLinks_LinkOrderConstraint_4004(
			StoryPattern container) {
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		for (Iterator<?> links = container.getLinkOrderConstraints().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof LinkOrderConstraint) {
				continue;
			}
			LinkOrderConstraint link = (LinkOrderConstraint) linkObject;
			if (LinkOrderConstraintEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			StoryPatternLink dst = link.getSuccessorLink();
			StoryPatternLink src = link.getPredecessorLink();
			result.add(new MlstorypatternsLinkDescriptor(src, dst, link,
					MlstorypatternsElementTypes.LinkOrderConstraint_4004,
					LinkOrderConstraintEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getContainedTypeModelFacetLinks_MapEntryLink_4005(
			StoryPattern container) {
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof MapEntryLink) {
				continue;
			}
			MapEntryLink link = (MapEntryLink) linkObject;
			if (MapEntryLinkEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlstorypatternsLinkDescriptor(src, dst, link,
					MlstorypatternsElementTypes.MapEntryLink_4005,
					MapEntryLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getIncomingTypeModelFacetLinks_StoryPatternLink_4001(
			AbstractStoryPatternObject target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() != MlstorypatternsPackage.eINSTANCE
					.getAbstractStoryPatternLink_Target()
					|| false == setting.getEObject() instanceof StoryPatternLink) {
				continue;
			}
			StoryPatternLink link = (StoryPatternLink) setting.getEObject();
			if (StoryPatternLinkEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlstorypatternsLinkDescriptor(src, target, link,
					MlstorypatternsElementTypes.StoryPatternLink_4001,
					StoryPatternLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getIncomingTypeModelFacetLinks_ContainmentLink_4002(
			AbstractStoryPatternObject target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() != MlstorypatternsPackage.eINSTANCE
					.getAbstractStoryPatternLink_Target()
					|| false == setting.getEObject() instanceof ContainmentLink) {
				continue;
			}
			ContainmentLink link = (ContainmentLink) setting.getEObject();
			if (ContainmentLinkEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlstorypatternsLinkDescriptor(src, target, link,
					MlstorypatternsElementTypes.ContainmentLink_4002,
					ContainmentLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getIncomingTypeModelFacetLinks_ExpressionLink_4003(
			AbstractStoryPatternObject target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() != MlstorypatternsPackage.eINSTANCE
					.getAbstractStoryPatternLink_Target()
					|| false == setting.getEObject() instanceof ExpressionLink) {
				continue;
			}
			ExpressionLink link = (ExpressionLink) setting.getEObject();
			if (ExpressionLinkEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlstorypatternsLinkDescriptor(src, target, link,
					MlstorypatternsElementTypes.ExpressionLink_4003,
					ExpressionLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getIncomingTypeModelFacetLinks_LinkOrderConstraint_4004(
			StoryPatternLink target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() != MlstorypatternsPackage.eINSTANCE
					.getLinkOrderConstraint_SuccessorLink()
					|| false == setting.getEObject() instanceof LinkOrderConstraint) {
				continue;
			}
			LinkOrderConstraint link = (LinkOrderConstraint) setting
					.getEObject();
			if (LinkOrderConstraintEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			StoryPatternLink src = link.getPredecessorLink();
			result.add(new MlstorypatternsLinkDescriptor(src, target, link,
					MlstorypatternsElementTypes.LinkOrderConstraint_4004,
					LinkOrderConstraintEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getIncomingTypeModelFacetLinks_MapEntryLink_4005(
			AbstractStoryPatternObject target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() != MlstorypatternsPackage.eINSTANCE
					.getAbstractStoryPatternLink_Target()
					|| false == setting.getEObject() instanceof MapEntryLink) {
				continue;
			}
			MapEntryLink link = (MapEntryLink) setting.getEObject();
			if (MapEntryLinkEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlstorypatternsLinkDescriptor(src, target, link,
					MlstorypatternsElementTypes.MapEntryLink_4005,
					MapEntryLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getIncomingFeatureModelFacetLinks_MapEntryLink_ValueTarget_4006(
			AbstractStoryPatternObject target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == MlstorypatternsPackage.eINSTANCE
					.getMapEntryLink_ValueTarget()) {
				result.add(new MlstorypatternsLinkDescriptor(
						setting.getEObject(),
						target,
						MlstorypatternsElementTypes.MapEntryLinkValueTarget_4006,
						MapEntryLinkValueTargetEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getOutgoingTypeModelFacetLinks_StoryPatternLink_4001(
			AbstractStoryPatternObject source) {
		StoryPattern container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof StoryPattern) {
				container = (StoryPattern) element;
			}
		}
		if (container == null) {
			return Collections.emptyList();
		}
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof StoryPatternLink) {
				continue;
			}
			StoryPatternLink link = (StoryPatternLink) linkObject;
			if (StoryPatternLinkEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			if (src != source) {
				continue;
			}
			result.add(new MlstorypatternsLinkDescriptor(src, dst, link,
					MlstorypatternsElementTypes.StoryPatternLink_4001,
					StoryPatternLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getOutgoingTypeModelFacetLinks_ContainmentLink_4002(
			AbstractStoryPatternObject source) {
		StoryPattern container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof StoryPattern) {
				container = (StoryPattern) element;
			}
		}
		if (container == null) {
			return Collections.emptyList();
		}
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof ContainmentLink) {
				continue;
			}
			ContainmentLink link = (ContainmentLink) linkObject;
			if (ContainmentLinkEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			if (src != source) {
				continue;
			}
			result.add(new MlstorypatternsLinkDescriptor(src, dst, link,
					MlstorypatternsElementTypes.ContainmentLink_4002,
					ContainmentLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getOutgoingTypeModelFacetLinks_ExpressionLink_4003(
			AbstractStoryPatternObject source) {
		StoryPattern container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof StoryPattern) {
				container = (StoryPattern) element;
			}
		}
		if (container == null) {
			return Collections.emptyList();
		}
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof ExpressionLink) {
				continue;
			}
			ExpressionLink link = (ExpressionLink) linkObject;
			if (ExpressionLinkEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			if (src != source) {
				continue;
			}
			result.add(new MlstorypatternsLinkDescriptor(src, dst, link,
					MlstorypatternsElementTypes.ExpressionLink_4003,
					ExpressionLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getOutgoingTypeModelFacetLinks_LinkOrderConstraint_4004(
			StoryPatternLink source) {
		StoryPattern container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof StoryPattern) {
				container = (StoryPattern) element;
			}
		}
		if (container == null) {
			return Collections.emptyList();
		}
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		for (Iterator<?> links = container.getLinkOrderConstraints().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof LinkOrderConstraint) {
				continue;
			}
			LinkOrderConstraint link = (LinkOrderConstraint) linkObject;
			if (LinkOrderConstraintEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			StoryPatternLink dst = link.getSuccessorLink();
			StoryPatternLink src = link.getPredecessorLink();
			if (src != source) {
				continue;
			}
			result.add(new MlstorypatternsLinkDescriptor(src, dst, link,
					MlstorypatternsElementTypes.LinkOrderConstraint_4004,
					LinkOrderConstraintEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getOutgoingTypeModelFacetLinks_MapEntryLink_4005(
			AbstractStoryPatternObject source) {
		StoryPattern container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof StoryPattern) {
				container = (StoryPattern) element;
			}
		}
		if (container == null) {
			return Collections.emptyList();
		}
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof MapEntryLink) {
				continue;
			}
			MapEntryLink link = (MapEntryLink) linkObject;
			if (MapEntryLinkEditPart.VISUAL_ID != MlstorypatternsVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			if (src != source) {
				continue;
			}
			result.add(new MlstorypatternsLinkDescriptor(src, dst, link,
					MlstorypatternsElementTypes.MapEntryLink_4005,
					MapEntryLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlstorypatternsLinkDescriptor> getOutgoingFeatureModelFacetLinks_MapEntryLink_ValueTarget_4006(
			MapEntryLink source) {
		LinkedList<MlstorypatternsLinkDescriptor> result = new LinkedList<MlstorypatternsLinkDescriptor>();
		AbstractStoryPatternObject destination = source.getValueTarget();
		if (destination == null) {
			return result;
		}
		result.add(new MlstorypatternsLinkDescriptor(source, destination,
				MlstorypatternsElementTypes.MapEntryLinkValueTarget_4006,
				MapEntryLinkValueTargetEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	public static final DiagramUpdater TYPED_INSTANCE = new DiagramUpdater() {
		/**
		 * @generated
		 */
		@Override
		public List<MlstorypatternsNodeDescriptor> getSemanticChildren(View view) {
			return MlstorypatternsDiagramUpdater.getSemanticChildren(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<MlstorypatternsLinkDescriptor> getContainedLinks(View view) {
			return MlstorypatternsDiagramUpdater.getContainedLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<MlstorypatternsLinkDescriptor> getIncomingLinks(View view) {
			return MlstorypatternsDiagramUpdater.getIncomingLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<MlstorypatternsLinkDescriptor> getOutgoingLinks(View view) {
			return MlstorypatternsDiagramUpdater.getOutgoingLinks(view);
		}
	};

}
