package de.mdelab.mlstorypatterns.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

import org.eclipse.gmf.tooling.runtime.structure.DiagramStructure;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlexpressions.MlexpressionsPackage;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.diagram.edit.parts.AttributeAssignmentEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.CallActionExpressionEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.LinkOrderConstraintEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MLStringExpressionEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternObjectNameEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel2EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel3EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel4EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel5EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel6EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel7EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabel8EditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabelEditPart;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class MlstorypatternsVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "de.mdelab.mlstorypatterns.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (StoryPatternEditPart.MODEL_ID.equals(view.getType())) {
				return StoryPatternEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				MlstorypatternsDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (MlstorypatternsPackage.eINSTANCE.getStoryPattern().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((StoryPattern) domainElement)) {
			return StoryPatternEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry
				.getModelID(containerView);
		if (!StoryPatternEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (StoryPatternEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = StoryPatternEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case StoryPatternEditPart.VISUAL_ID:
			if (MlstorypatternsPackage.eINSTANCE.getStoryPatternObject()
					.isSuperTypeOf(domainElement.eClass())) {
				return StoryPatternObjectEditPart.VISUAL_ID;
			}
			break;
		case StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID:
			if (MlexpressionsPackage.eINSTANCE.getMLStringExpression()
					.isSuperTypeOf(domainElement.eClass())) {
				return MLStringExpressionEditPart.VISUAL_ID;
			}
			if (MlcallactionsPackage.eINSTANCE.getCallActionExpression()
					.isSuperTypeOf(domainElement.eClass())) {
				return CallActionExpressionEditPart.VISUAL_ID;
			}
			break;
		case StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID:
			if (MlstorypatternsPackage.eINSTANCE.getAttributeAssignment()
					.isSuperTypeOf(domainElement.eClass())) {
				return AttributeAssignmentEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry
				.getModelID(containerView);
		if (!StoryPatternEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (StoryPatternEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = StoryPatternEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case StoryPatternEditPart.VISUAL_ID:
			if (StoryPatternObjectEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case StoryPatternObjectEditPart.VISUAL_ID:
			if (StoryPatternObjectNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (WrappingLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (WrappingLabel2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID:
			if (MLStringExpressionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CallActionExpressionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID:
			if (AttributeAssignmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case StoryPatternLinkEditPart.VISUAL_ID:
			if (WrappingLabel3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (WrappingLabel4EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ExpressionLinkEditPart.VISUAL_ID:
			if (WrappingLabel5EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MapEntryLinkEditPart.VISUAL_ID:
			if (WrappingLabel6EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (WrappingLabel7EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MapEntryLinkValueTargetEditPart.VISUAL_ID:
			if (WrappingLabel8EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (MlstorypatternsPackage.eINSTANCE.getStoryPatternLink()
				.isSuperTypeOf(domainElement.eClass())) {
			return StoryPatternLinkEditPart.VISUAL_ID;
		}
		if (MlstorypatternsPackage.eINSTANCE.getContainmentLink()
				.isSuperTypeOf(domainElement.eClass())) {
			return ContainmentLinkEditPart.VISUAL_ID;
		}
		if (MlstorypatternsPackage.eINSTANCE.getExpressionLink().isSuperTypeOf(
				domainElement.eClass())) {
			return ExpressionLinkEditPart.VISUAL_ID;
		}
		if (MlstorypatternsPackage.eINSTANCE.getLinkOrderConstraint()
				.isSuperTypeOf(domainElement.eClass())) {
			return LinkOrderConstraintEditPart.VISUAL_ID;
		}
		if (MlstorypatternsPackage.eINSTANCE.getMapEntryLink().isSuperTypeOf(
				domainElement.eClass())) {
			return MapEntryLinkEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(StoryPattern element) {
		return true;
	}

	/**
	 * @generated
	 */
	public static boolean checkNodeVisualID(View containerView,
			EObject domainElement, int candidate) {
		if (candidate == -1) {
			//unrecognized id is always bad
			return false;
		}
		int basic = getNodeVisualID(containerView, domainElement);
		return basic == candidate;
	}

	/**
	 * @generated
	 */
	public static boolean isCompartmentVisualID(int visualID) {
		switch (visualID) {
		case StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID:
		case StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static boolean isSemanticLeafVisualID(int visualID) {
		switch (visualID) {
		case StoryPatternEditPart.VISUAL_ID:
			return false;
		case MLStringExpressionEditPart.VISUAL_ID:
		case AttributeAssignmentEditPart.VISUAL_ID:
		case CallActionExpressionEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static final DiagramStructure TYPED_INSTANCE = new DiagramStructure() {
		/**
		 * @generated
		 */
		@Override
		public int getVisualID(View view) {
			return de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry
					.getVisualID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public String getModelID(View view) {
			return de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry
					.getModelID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public int getNodeVisualID(View containerView, EObject domainElement) {
			return de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry
					.getNodeVisualID(containerView, domainElement);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean checkNodeVisualID(View containerView,
				EObject domainElement, int candidate) {
			return de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry
					.checkNodeVisualID(containerView, domainElement, candidate);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isCompartmentVisualID(int visualID) {
			return de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry
					.isCompartmentVisualID(visualID);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isSemanticLeafVisualID(int visualID) {
			return de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsVisualIDRegistry
					.isSemanticLeafVisualID(visualID);
		}
	};

}
