package de.mdelab.mlstorypatterns.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlexpressions.MlexpressionsPackage;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.diagram.edit.parts.AttributeAssignmentEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.CallActionExpressionEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.LinkOrderConstraintEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MLStringExpressionEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlstorypatterns.diagram.part.MlstorypatternsDiagramEditorPlugin;

/**
 * @generated
 */
public class MlstorypatternsElementTypes {

	/**
	 * @generated
	 */
	private MlstorypatternsElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement> elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType StoryPattern_1000 = getElementType("de.mdelab.mlstorypatterns.diagram.StoryPattern_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType StoryPatternObject_2003 = getElementType("de.mdelab.mlstorypatterns.diagram.StoryPatternObject_2003"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType MLStringExpression_3001 = getElementType("de.mdelab.mlstorypatterns.diagram.MLStringExpression_3001"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType AttributeAssignment_3002 = getElementType("de.mdelab.mlstorypatterns.diagram.AttributeAssignment_3002"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType CallActionExpression_3003 = getElementType("de.mdelab.mlstorypatterns.diagram.CallActionExpression_3003"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType StoryPatternLink_4001 = getElementType("de.mdelab.mlstorypatterns.diagram.StoryPatternLink_4001"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType ContainmentLink_4002 = getElementType("de.mdelab.mlstorypatterns.diagram.ContainmentLink_4002"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType ExpressionLink_4003 = getElementType("de.mdelab.mlstorypatterns.diagram.ExpressionLink_4003"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType LinkOrderConstraint_4004 = getElementType("de.mdelab.mlstorypatterns.diagram.LinkOrderConstraint_4004"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType MapEntryLink_4005 = getElementType("de.mdelab.mlstorypatterns.diagram.MapEntryLink_4005"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType MapEntryLinkValueTarget_4006 = getElementType("de.mdelab.mlstorypatterns.diagram.MapEntryLinkValueTarget_4006"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return MlstorypatternsDiagramEditorPlugin.getInstance()
						.getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(StoryPattern_1000,
					MlstorypatternsPackage.eINSTANCE.getStoryPattern());

			elements.put(StoryPatternObject_2003,
					MlstorypatternsPackage.eINSTANCE.getStoryPatternObject());

			elements.put(MLStringExpression_3001,
					MlexpressionsPackage.eINSTANCE.getMLStringExpression());

			elements.put(AttributeAssignment_3002,
					MlstorypatternsPackage.eINSTANCE.getAttributeAssignment());

			elements.put(CallActionExpression_3003,
					MlcallactionsPackage.eINSTANCE.getCallActionExpression());

			elements.put(StoryPatternLink_4001,
					MlstorypatternsPackage.eINSTANCE.getStoryPatternLink());

			elements.put(ContainmentLink_4002,
					MlstorypatternsPackage.eINSTANCE.getContainmentLink());

			elements.put(ExpressionLink_4003,
					MlstorypatternsPackage.eINSTANCE.getExpressionLink());

			elements.put(LinkOrderConstraint_4004,
					MlstorypatternsPackage.eINSTANCE.getLinkOrderConstraint());

			elements.put(MapEntryLink_4005,
					MlstorypatternsPackage.eINSTANCE.getMapEntryLink());

			elements.put(MapEntryLinkValueTarget_4006,
					MlstorypatternsPackage.eINSTANCE
							.getMapEntryLink_ValueTarget());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(StoryPattern_1000);
			KNOWN_ELEMENT_TYPES.add(StoryPatternObject_2003);
			KNOWN_ELEMENT_TYPES.add(MLStringExpression_3001);
			KNOWN_ELEMENT_TYPES.add(AttributeAssignment_3002);
			KNOWN_ELEMENT_TYPES.add(CallActionExpression_3003);
			KNOWN_ELEMENT_TYPES.add(StoryPatternLink_4001);
			KNOWN_ELEMENT_TYPES.add(ContainmentLink_4002);
			KNOWN_ELEMENT_TYPES.add(ExpressionLink_4003);
			KNOWN_ELEMENT_TYPES.add(LinkOrderConstraint_4004);
			KNOWN_ELEMENT_TYPES.add(MapEntryLink_4005);
			KNOWN_ELEMENT_TYPES.add(MapEntryLinkValueTarget_4006);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case StoryPatternEditPart.VISUAL_ID:
			return StoryPattern_1000;
		case StoryPatternObjectEditPart.VISUAL_ID:
			return StoryPatternObject_2003;
		case MLStringExpressionEditPart.VISUAL_ID:
			return MLStringExpression_3001;
		case AttributeAssignmentEditPart.VISUAL_ID:
			return AttributeAssignment_3002;
		case CallActionExpressionEditPart.VISUAL_ID:
			return CallActionExpression_3003;
		case StoryPatternLinkEditPart.VISUAL_ID:
			return StoryPatternLink_4001;
		case ContainmentLinkEditPart.VISUAL_ID:
			return ContainmentLink_4002;
		case ExpressionLinkEditPart.VISUAL_ID:
			return ExpressionLink_4003;
		case LinkOrderConstraintEditPart.VISUAL_ID:
			return LinkOrderConstraint_4004;
		case MapEntryLinkEditPart.VISUAL_ID:
			return MapEntryLink_4005;
		case MapEntryLinkValueTargetEditPart.VISUAL_ID:
			return MapEntryLinkValueTarget_4006;
		}
		return null;
	}

}
