/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlstorypatterns.MatchTypeEnum;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPatternElement;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Story Pattern Element</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternElementImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternElementImpl#getModifier <em>Modifier</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternElementImpl#getMatchType <em>Match Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class StoryPatternElementImpl extends MLElementWithUUIDImpl
		implements StoryPatternElement {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The default value of the '{@link #getModifier() <em>Modifier</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getModifier()
	 * @generated
	 * @ordered
	 */
	protected static final ModifierEnum MODIFIER_EDEFAULT = ModifierEnum.NONE;

	/**
	 * The cached value of the '{@link #getModifier() <em>Modifier</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getModifier()
	 * @generated
	 * @ordered
	 */
	protected ModifierEnum modifier = MODIFIER_EDEFAULT;

	/**
	 * The default value of the '{@link #getMatchType() <em>Match Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMatchType()
	 * @generated
	 * @ordered
	 */
	protected static final MatchTypeEnum MATCH_TYPE_EDEFAULT = MatchTypeEnum.DEFAULT;

	/**
	 * The cached value of the '{@link #getMatchType() <em>Match Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMatchType()
	 * @generated
	 * @ordered
	 */
	protected MatchTypeEnum matchType = MATCH_TYPE_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected StoryPatternElementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.STORY_PATTERN_ELEMENT;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(
					MLAnnotation.class, this,
					MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS,
					MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ModifierEnum getModifier() {
		return modifier;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setModifier(ModifierEnum newModifier) {
		ModifierEnum oldModifier = modifier;
		modifier = newModifier == null ? MODIFIER_EDEFAULT : newModifier;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MODIFIER,
					oldModifier, modifier));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MatchTypeEnum getMatchType() {
		return matchType;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMatchType(MatchTypeEnum newMatchType) {
		MatchTypeEnum oldMatchType = matchType;
		matchType = newMatchType == null ? MATCH_TYPE_EDEFAULT : newMatchType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MATCH_TYPE,
					oldMatchType, matchType));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations())
					.basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS:
			return ((InternalEList<?>) getAnnotations()).basicRemove(otherEnd,
					msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS:
			return getAnnotations();
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MODIFIER:
			return getModifier();
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MATCH_TYPE:
			return getMatchType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS:
			getAnnotations().clear();
			getAnnotations().addAll(
					(Collection<? extends MLAnnotation>) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MODIFIER:
			setModifier((ModifierEnum) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MATCH_TYPE:
			setMatchType((MatchTypeEnum) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS:
			getAnnotations().clear();
			return;
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MODIFIER:
			setModifier(MODIFIER_EDEFAULT);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MATCH_TYPE:
			setMatchType(MATCH_TYPE_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS:
			return annotations != null && !annotations.isEmpty();
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MODIFIER:
			return modifier != MODIFIER_EDEFAULT;
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__MATCH_TYPE:
			return matchType != MATCH_TYPE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
			case MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS:
				return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
			case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
				return MlstorypatternsPackage.STORY_PATTERN_ELEMENT__ANNOTATIONS;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (modifier: ");
		result.append(modifier);
		result.append(", matchType: ");
		result.append(matchType);
		result.append(')');
		return result.toString();
	}

} // StoryPatternElementImpl
