/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPattern;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Story Pattern</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getStoryPatternLinks <em>Story Pattern Links</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getStoryPatternObjects <em>Story Pattern Objects</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getLinkOrderConstraints <em>Link Order Constraints</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getConstraints <em>Constraints</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getNegativeApplicationConditions <em>Negative Application Conditions</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternImpl#getContainingPattern <em>Containing Pattern</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class StoryPatternImpl extends MLElementWithUUIDImpl implements
		StoryPattern {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStoryPatternLinks()
	 * <em>Story Pattern Links</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStoryPatternLinks()
	 * @generated
	 * @ordered
	 */
	protected EList<AbstractStoryPatternLink> storyPatternLinks;

	/**
	 * The cached value of the '{@link #getStoryPatternObjects()
	 * <em>Story Pattern Objects</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStoryPatternObjects()
	 * @generated
	 * @ordered
	 */
	protected EList<AbstractStoryPatternObject> storyPatternObjects;

	/**
	 * The cached value of the '{@link #getLinkOrderConstraints()
	 * <em>Link Order Constraints</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getLinkOrderConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<LinkOrderConstraint> linkOrderConstraints;

	/**
	 * The cached value of the '{@link #getConstraints() <em>Constraints</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<MLExpression> constraints;

	/**
	 * The cached value of the '{@link #getNegativeApplicationConditions() <em>Negative Application Conditions</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getNegativeApplicationConditions()
	 * @generated
	 * @ordered
	 */
	protected EList<StoryPattern> negativeApplicationConditions;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected StoryPatternImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.STORY_PATTERN;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(
					MLAnnotation.class, this,
					MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS,
					MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<AbstractStoryPatternLink> getStoryPatternLinks() {
		if (storyPatternLinks == null) {
			storyPatternLinks = new EObjectContainmentWithInverseEList<AbstractStoryPatternLink>(
					AbstractStoryPatternLink.class,
					this,
					MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN);
		}
		return storyPatternLinks;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<AbstractStoryPatternObject> getStoryPatternObjects() {
		if (storyPatternObjects == null) {
			storyPatternObjects = new EObjectContainmentWithInverseEList<AbstractStoryPatternObject>(
					AbstractStoryPatternObject.class,
					this,
					MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN);
		}
		return storyPatternObjects;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<LinkOrderConstraint> getLinkOrderConstraints() {
		if (linkOrderConstraints == null) {
			linkOrderConstraints = new EObjectContainmentWithInverseEList<LinkOrderConstraint>(
					LinkOrderConstraint.class,
					this,
					MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN);
		}
		return linkOrderConstraints;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLExpression> getConstraints() {
		if (constraints == null) {
			constraints = new EObjectContainmentEList<MLExpression>(
					MLExpression.class, this,
					MlstorypatternsPackage.STORY_PATTERN__CONSTRAINTS);
		}
		return constraints;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<StoryPattern> getNegativeApplicationConditions() {
		if (negativeApplicationConditions == null) {
			negativeApplicationConditions = new EObjectContainmentWithInverseEList<StoryPattern>(
					StoryPattern.class,
					this,
					MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS,
					MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN);
		}
		return negativeApplicationConditions;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPattern getContainingPattern() {
		if (eContainerFeatureID() != MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN)
			return null;
		return (StoryPattern) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetContainingPattern(
			StoryPattern newContainingPattern, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newContainingPattern,
				MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setContainingPattern(StoryPattern newContainingPattern) {
		if (newContainingPattern != eInternalContainer()
				|| (eContainerFeatureID() != MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN && newContainingPattern != null)) {
			if (EcoreUtil.isAncestor(this, newContainingPattern))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newContainingPattern != null)
				msgs = ((InternalEObject) newContainingPattern)
						.eInverseAdd(
								this,
								MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS,
								StoryPattern.class, msgs);
			msgs = basicSetContainingPattern(newContainingPattern, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN,
					newContainingPattern, newContainingPattern));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations())
					.basicAdd(otherEnd, msgs);
		case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getStoryPatternLinks())
					.basicAdd(otherEnd, msgs);
		case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getStoryPatternObjects())
					.basicAdd(otherEnd, msgs);
		case MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getLinkOrderConstraints())
					.basicAdd(otherEnd, msgs);
		case MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getNegativeApplicationConditions())
					.basicAdd(otherEnd, msgs);
		case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetContainingPattern((StoryPattern) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS:
			return ((InternalEList<?>) getAnnotations()).basicRemove(otherEnd,
					msgs);
		case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS:
			return ((InternalEList<?>) getStoryPatternLinks()).basicRemove(
					otherEnd, msgs);
		case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS:
			return ((InternalEList<?>) getStoryPatternObjects()).basicRemove(
					otherEnd, msgs);
		case MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS:
			return ((InternalEList<?>) getLinkOrderConstraints()).basicRemove(
					otherEnd, msgs);
		case MlstorypatternsPackage.STORY_PATTERN__CONSTRAINTS:
			return ((InternalEList<?>) getConstraints()).basicRemove(otherEnd,
					msgs);
		case MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS:
			return ((InternalEList<?>) getNegativeApplicationConditions())
					.basicRemove(otherEnd, msgs);
		case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN:
			return basicSetContainingPattern(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
		case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN:
			return eInternalContainer()
					.eInverseRemove(
							this,
							MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS,
							StoryPattern.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS:
			return getAnnotations();
		case MlstorypatternsPackage.STORY_PATTERN__NAME:
			return getName();
		case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS:
			return getStoryPatternLinks();
		case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS:
			return getStoryPatternObjects();
		case MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS:
			return getLinkOrderConstraints();
		case MlstorypatternsPackage.STORY_PATTERN__CONSTRAINTS:
			return getConstraints();
		case MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS:
			return getNegativeApplicationConditions();
		case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN:
			return getContainingPattern();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS:
			getAnnotations().clear();
			getAnnotations().addAll(
					(Collection<? extends MLAnnotation>) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN__NAME:
			setName((String) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS:
			getStoryPatternLinks().clear();
			getStoryPatternLinks().addAll(
					(Collection<? extends AbstractStoryPatternLink>) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS:
			getStoryPatternObjects().clear();
			getStoryPatternObjects()
					.addAll((Collection<? extends AbstractStoryPatternObject>) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS:
			getLinkOrderConstraints().clear();
			getLinkOrderConstraints().addAll(
					(Collection<? extends LinkOrderConstraint>) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN__CONSTRAINTS:
			getConstraints().clear();
			getConstraints().addAll(
					(Collection<? extends MLExpression>) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS:
			getNegativeApplicationConditions().clear();
			getNegativeApplicationConditions().addAll(
					(Collection<? extends StoryPattern>) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN:
			setContainingPattern((StoryPattern) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS:
			getAnnotations().clear();
			return;
		case MlstorypatternsPackage.STORY_PATTERN__NAME:
			setName(NAME_EDEFAULT);
			return;
		case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS:
			getStoryPatternLinks().clear();
			return;
		case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS:
			getStoryPatternObjects().clear();
			return;
		case MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS:
			getLinkOrderConstraints().clear();
			return;
		case MlstorypatternsPackage.STORY_PATTERN__CONSTRAINTS:
			getConstraints().clear();
			return;
		case MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS:
			getNegativeApplicationConditions().clear();
			return;
		case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN:
			setContainingPattern((StoryPattern) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS:
			return annotations != null && !annotations.isEmpty();
		case MlstorypatternsPackage.STORY_PATTERN__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT
					.equals(name);
		case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS:
			return storyPatternLinks != null && !storyPatternLinks.isEmpty();
		case MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS:
			return storyPatternObjects != null
					&& !storyPatternObjects.isEmpty();
		case MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS:
			return linkOrderConstraints != null
					&& !linkOrderConstraints.isEmpty();
		case MlstorypatternsPackage.STORY_PATTERN__CONSTRAINTS:
			return constraints != null && !constraints.isEmpty();
		case MlstorypatternsPackage.STORY_PATTERN__NEGATIVE_APPLICATION_CONDITIONS:
			return negativeApplicationConditions != null
					&& !negativeApplicationConditions.isEmpty();
		case MlstorypatternsPackage.STORY_PATTERN__CONTAINING_PATTERN:
			return getContainingPattern() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
			case MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS:
				return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
			default:
				return -1;
			}
		}
		if (baseClass == MLNamedElement.class) {
			switch (derivedFeatureID) {
			case MlstorypatternsPackage.STORY_PATTERN__NAME:
				return MlcorePackage.ML_NAMED_ELEMENT__NAME;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
			case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
				return MlstorypatternsPackage.STORY_PATTERN__ANNOTATIONS;
			default:
				return -1;
			}
		}
		if (baseClass == MLNamedElement.class) {
			switch (baseFeatureID) {
			case MlcorePackage.ML_NAMED_ELEMENT__NAME:
				return MlstorypatternsPackage.STORY_PATTERN__NAME;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} // StoryPatternImpl
