/**
 */
package de.mdelab.mlstorypatterns.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.EMFEditPlugin;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;

/**
 * This is the item provider adapter for a {@link de.mdelab.mlstorypatterns.MapEntryLink} object.
 * <!-- begin-user-doc
 * --> <!-- end-user-doc -->
 * @generated
 */
public class MapEntryLinkItemProvider extends
		AbstractStoryPatternLinkItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public MapEntryLinkItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addFeaturePropertyDescriptor(object);
			addValueTargetPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Feature feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addFeaturePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_MapEntryLink_feature_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_MapEntryLink_feature_feature",
						"_UI_MapEntryLink_type"),
				MlstorypatternsPackage.Literals.MAP_ENTRY_LINK__FEATURE, true,
				false, true, null, null, null));
	}

	/**
	 * This adds a property descriptor for the Value Target feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addValueTargetPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_MapEntryLink_valueTarget_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_MapEntryLink_valueTarget_feature",
						"_UI_MapEntryLink_type"),
				MlstorypatternsPackage.Literals.MAP_ENTRY_LINK__VALUE_TARGET,
				true, false, true, null, null, null));
	}

	/**
	 * This returns MapEntryLink.gif. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object,
				getResourceLocator().getImage("full/obj16/MapEntryLink"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public String getText(final Object object) {
		String label = this.getString("_UI_MapEntryLink_type");

		label += " ";

		final MapEntryLink link = (MapEntryLink) object;

		final ComposedAdapterFactory factory = new ComposedAdapterFactory(
				EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());

		if (link.getSource() != null) {
			label += ((IItemLabelProvider) factory.adapt(link.getSource(),
					IItemLabelProvider.class)).getText(link.getSource());
		} else {
			label += "[null]";
		}

		label += ".";

		if (link.getFeature() != null) {
			label += link.getFeature().getName();
		} else {
			label += "[null]";
		}

		label += " ==> (";

		if (link.getTarget() != null) {
			label += ((IItemLabelProvider) factory.adapt(link.getTarget(),
					IItemLabelProvider.class)).getText(link.getTarget());
		} else {
			label += "[null]";
		}

		label += ", ";

		if (link.getValueTarget() != null) {
			label += ((IItemLabelProvider) factory.adapt(link.getValueTarget(),
					IItemLabelProvider.class)).getText(link.getValueTarget());
		} else {
			label += "[null]";
		}

		label += ")";

		return label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(MapEntryLink.class)) {
		case MlstorypatternsPackage.MAP_ENTRY_LINK__FEATURE:
		case MlstorypatternsPackage.MAP_ENTRY_LINK__VALUE_TARGET:
			fireNotifyChanged(new ViewerNotification(notification,
					notification.getNotifier(), false, true));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(
			Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
