/**
 */
package de.mdelab.mlstorypatterns.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.Switch;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.ContainmentLink;
import de.mdelab.mlstorypatterns.ExpressionLink;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import de.mdelab.mlstorypatterns.StoryPatternObject;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage
 * @generated
 */
public class MlstorypatternsSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static MlstorypatternsPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public MlstorypatternsSwitch() {
		if (modelPackage == null) {
			modelPackage = MlstorypatternsPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
		case MlstorypatternsPackage.STORY_PATTERN: {
			StoryPattern storyPattern = (StoryPattern) theEObject;
			T result = caseStoryPattern(storyPattern);
			if (result == null)
				result = caseMLElementWithUUID(storyPattern);
			if (result == null)
				result = caseMLAnnotatedElement(storyPattern);
			if (result == null)
				result = caseMLNamedElement(storyPattern);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlstorypatternsPackage.STORY_PATTERN_ELEMENT: {
			StoryPatternElement storyPatternElement = (StoryPatternElement) theEObject;
			T result = caseStoryPatternElement(storyPatternElement);
			if (result == null)
				result = caseMLElementWithUUID(storyPatternElement);
			if (result == null)
				result = caseMLAnnotatedElement(storyPatternElement);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT: {
			AbstractStoryPatternObject abstractStoryPatternObject = (AbstractStoryPatternObject) theEObject;
			T result = caseAbstractStoryPatternObject(abstractStoryPatternObject);
			if (result == null)
				result = caseStoryPatternElement(abstractStoryPatternObject);
			if (result == null)
				result = caseMLNamedElement(abstractStoryPatternObject);
			if (result == null)
				result = caseMLTypedElement(abstractStoryPatternObject);
			if (result == null)
				result = caseMLElementWithUUID(abstractStoryPatternObject);
			if (result == null)
				result = caseMLAnnotatedElement(abstractStoryPatternObject);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT: {
			StoryPatternObject storyPatternObject = (StoryPatternObject) theEObject;
			T result = caseStoryPatternObject(storyPatternObject);
			if (result == null)
				result = caseAbstractStoryPatternObject(storyPatternObject);
			if (result == null)
				result = caseStoryPatternElement(storyPatternObject);
			if (result == null)
				result = caseMLNamedElement(storyPatternObject);
			if (result == null)
				result = caseMLTypedElement(storyPatternObject);
			if (result == null)
				result = caseMLElementWithUUID(storyPatternObject);
			if (result == null)
				result = caseMLAnnotatedElement(storyPatternObject);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT: {
			AttributeAssignment attributeAssignment = (AttributeAssignment) theEObject;
			T result = caseAttributeAssignment(attributeAssignment);
			if (result == null)
				result = caseMLElementWithUUID(attributeAssignment);
			if (result == null)
				result = caseMLAnnotatedElement(attributeAssignment);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK: {
			AbstractStoryPatternLink abstractStoryPatternLink = (AbstractStoryPatternLink) theEObject;
			T result = caseAbstractStoryPatternLink(abstractStoryPatternLink);
			if (result == null)
				result = caseStoryPatternElement(abstractStoryPatternLink);
			if (result == null)
				result = caseMLElementWithUUID(abstractStoryPatternLink);
			if (result == null)
				result = caseMLAnnotatedElement(abstractStoryPatternLink);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlstorypatternsPackage.STORY_PATTERN_LINK: {
			StoryPatternLink storyPatternLink = (StoryPatternLink) theEObject;
			T result = caseStoryPatternLink(storyPatternLink);
			if (result == null)
				result = caseAbstractStoryPatternLink(storyPatternLink);
			if (result == null)
				result = caseStoryPatternElement(storyPatternLink);
			if (result == null)
				result = caseMLElementWithUUID(storyPatternLink);
			if (result == null)
				result = caseMLAnnotatedElement(storyPatternLink);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlstorypatternsPackage.CONTAINMENT_LINK: {
			ContainmentLink containmentLink = (ContainmentLink) theEObject;
			T result = caseContainmentLink(containmentLink);
			if (result == null)
				result = caseAbstractStoryPatternLink(containmentLink);
			if (result == null)
				result = caseStoryPatternElement(containmentLink);
			if (result == null)
				result = caseMLElementWithUUID(containmentLink);
			if (result == null)
				result = caseMLAnnotatedElement(containmentLink);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlstorypatternsPackage.EXPRESSION_LINK: {
			ExpressionLink expressionLink = (ExpressionLink) theEObject;
			T result = caseExpressionLink(expressionLink);
			if (result == null)
				result = caseAbstractStoryPatternLink(expressionLink);
			if (result == null)
				result = caseStoryPatternElement(expressionLink);
			if (result == null)
				result = caseMLElementWithUUID(expressionLink);
			if (result == null)
				result = caseMLAnnotatedElement(expressionLink);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlstorypatternsPackage.MAP_ENTRY_LINK: {
			MapEntryLink mapEntryLink = (MapEntryLink) theEObject;
			T result = caseMapEntryLink(mapEntryLink);
			if (result == null)
				result = caseAbstractStoryPatternLink(mapEntryLink);
			if (result == null)
				result = caseStoryPatternElement(mapEntryLink);
			if (result == null)
				result = caseMLElementWithUUID(mapEntryLink);
			if (result == null)
				result = caseMLAnnotatedElement(mapEntryLink);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT: {
			LinkOrderConstraint linkOrderConstraint = (LinkOrderConstraint) theEObject;
			T result = caseLinkOrderConstraint(linkOrderConstraint);
			if (result == null)
				result = caseMLElementWithUUID(linkOrderConstraint);
			if (result == null)
				result = caseMLAnnotatedElement(linkOrderConstraint);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		default:
			return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Story Pattern</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Story Pattern</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStoryPattern(StoryPattern object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Story Pattern Element</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Story Pattern Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStoryPatternElement(StoryPatternElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Abstract Story Pattern Object</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Abstract Story Pattern Object</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAbstractStoryPatternObject(AbstractStoryPatternObject object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Story Pattern Object</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Story Pattern Object</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStoryPatternObject(StoryPatternObject object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Attribute Assignment</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Attribute Assignment</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAttributeAssignment(AttributeAssignment object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Abstract Story Pattern Link</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Abstract Story Pattern Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAbstractStoryPatternLink(AbstractStoryPatternLink object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Story Pattern Link</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Story Pattern Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStoryPatternLink(StoryPatternLink object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Containment Link</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Containment Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseContainmentLink(ContainmentLink object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Expression Link</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Expression Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseExpressionLink(ExpressionLink object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Map Entry Link</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Map Entry Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMapEntryLink(MapEntryLink object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Link Order Constraint</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Link Order Constraint</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLinkOrderConstraint(LinkOrderConstraint object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Annotated Element</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Annotated Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLAnnotatedElement(MLAnnotatedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Element With UUID</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Element With UUID</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLElementWithUUID(MLElementWithUUID object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Named Element</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Named Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLNamedElement(MLNamedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Typed Element</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Typed Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLTypedElement(MLTypedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch, but this is
	 * the last case anyway. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} // MlstorypatternsSwitch
